博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
HDU4960Another OCD Patient(间隙dp,后座DP)
阅读量:6950 次
发布时间:2019-06-27

本文共 2540 字,大约阅读时间需要 8 分钟。

Another OCD Patient

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 716    Accepted Submission(s): 270
Problem Description
Xiaoji is an OCD (obsessive-compulsive disorder) patient. This morning, his children played with plasticene. They broke the plasticene into N pieces, and put them in a line. Each piece has a volume Vi. Since Xiaoji is an OCD patient, he can't stand with the disorder of the volume of the N pieces of plasticene. Now he wants to merge some successive pieces so that the volume in line is symmetrical! For example, (10, 20, 20, 10), (4,1,4) and (2) are symmetrical but (3,1,2), (3, 1, 1) and (1, 2, 1, 2) are not.
However, because Xiaoji's OCD is more and more serious, now he has a strange opinion that merging i successive pieces into one will cost ai. And he wants to achieve his goal with minimum cost. Can you help him?
By the way, if one piece is merged by Xiaoji, he would not use it to merge again. Don't ask why. You should know Xiaoji has an OCD.
Input
The input contains multiple test cases.
The first line of each case is an integer N (0 < N <= 5000), indicating the number of pieces in a line. The second line contains N integers Vi, volume of each piece (0 < Vi <=10^9). The third line contains N integers ai
(0 < ai <=10000), and a1 is always 0.
The input is terminated by N = 0.
Output
Output one line containing the minimum cost of all operations Xiaoji needs.
Sample Input
 
5 6 2 8 7 1 0 5 2 10 20 0
Sample Output
 
10
Hint
In the sample, there is two ways to achieve Xiaoji's goal. [6 2 8 7 1] -> [8 8 7 1] -> [8 8 8] will cost 5 + 5 = 10. [6 2 8 7 1] -> [24] will cost 20.
Author
SYSU
Source
题意:给出n个数,把这n个数合成一个对称的集合。第三行代表一次合成i个数须要花费a[i],求出最小的花费。
解题:先把n个数合成一个对称集合共k个块,再进行对称区间DP。

#include
__int64 v[5005],a[5005],pre[5005],dp[5005];void dfs(int l,int r)//分块,使[l,r]对称{ int i=l,j=r; __int64 suml=v[l],sumr=v[r]; while(i
dp[tr-1]+a[pre[r]-pre[tr-1]]+a[pre[tl]-pre[l-1]]) dp[r]=dp[tr-1]+a[pre[r]-pre[tr-1]]+a[pre[tl]-pre[l-1]]; l--;r++;//向两边扩增 }}int main(){ int n,i,k; __int64 tk; while(scanf("%d",&n)>0&&n) { for( i=1;i<=n;i++)scanf("%I64d",&v[i]); for( i=1;i<=n;i++)scanf("%I64d",&a[i]); dfs(1,n); k=0; i=1;pre[0]=0; while(i<=n)//把一整块缩成一个点,pre[k]变成前k个块共同拥有多少个数组成k块 { tk=pre[i]-i+1; i=pre[i]+1; ++k; pre[k]=tk+pre[k-1]; } count(k); printf("%I64d\n",dp[k]); }}

版权声明:本文博主原创文章,博客,未经同意不得转载。

你可能感兴趣的文章
golang 性能测试pprof
查看>>
ubuntu开机只有一条横杠在闪的解决办法
查看>>
分享幻灯片+在线阅读
查看>>
塔式、机架式、刀片式服务器的区别和特点
查看>>
25、Base64
查看>>
如何用 Canvas绘制图形
查看>>
Dynamics CRM 系统自定义部分的语言翻译
查看>>
Makefile学习与进阶之Makefile.am和$$(M)的意思
查看>>
Codeforces Round #382 (Div. 2)
查看>>
日历控件--My97DatePicker的使用
查看>>
k8s运行容器之Job(四)--技术流ken
查看>>
Android下打印调试堆栈方法(转)
查看>>
iOS7坐标上移44pt的解决
查看>>
面向对象基础
查看>>
Python全栈开发—第1站
查看>>
15 函数回调 模块
查看>>
iOS掉落回弹效果
查看>>
Eclipse--eclipse去除js(JavaScript)验证错误
查看>>
mac关闭和开启启动声
查看>>
浅谈WebService开发(一)
查看>>